image: node:latest
stages:
    - build
    - test
    - deploy staging
    - deploy production
    - production tests
    - cache
cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - node_modules/
    policy: pull
variables:
    STAGING_DOMAIN: tiny-tub-staging.surge.sh
    PRODUCTION_DOMAIN: tiny-tub.surge.sh
build website:
    stage: build
    script:
        - echo $CI_COMMIT_SHORT_SHA
        - npm install
        - npm install -g gatsby-cli
        - gatsby build
        - sed -i 's/%%VERSION%%/$CI_COMMIT_SHORT_SHA/' public/index.html
    artifacts:
        paths:
            - public/
    except: 
        - scheedules
test artifact:
    cache: {}
    image: alpine
    stage: test
    script:
        - grep -q "Gatsby" public/index.html
    except:
        - schedules
test website:
    cache:
        policy: push
    stage: test
    script:
        - npm install
        - npm install -g gatsby-cli
        - gatsby serve &
        - sleep 3
        - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"
    except:
        - schedules
deploy staging:
    stage: deploy staging
    environment:
        name: staging
        url: https://$STAGING_DOMAIN
    script:
        - npm install --global surge
        - surge --project public/ --domain $STAGING_DOMAIN
        - sleep 3
    except:
        - schedules
deploy production:
    stage: deploy production
    environment:
        name: production
        url: https://$PRODUCTION_DOMAIN
    script:
        - npm install --global surge
        - surge --project public/ --domain $PRODUCTION_DOMAIN
        - sleep 3
    except:
        - schedules
production test:
    stage: production tests
    cache:
        policy: pull
    image: alpine
    stage: production tests
    script:
        - apk update
        - apk upgrade
        - apk add curl
        - curl "https://$PRODUCTION_DOMAIN" | grep -q "Congratulations"
        - curl "https://$PRODUCTION_DOMAIN" | grep -q "$CI_COMMIT_SHORT_SHA"
    except:
        - schedules
update cache:
  stage: cache
  script:
    - npm install
  cache:
      key: ${CI_COMMIT_REF_SLUG}
      paths:
        - node_modules/
      policy: push
  only:
    - schedules
